import { FieldValues } from './fields';
import { Control } from './form';
import { Auto, FieldPathValue, PathString } from './path';
export declare type UseFieldArrayProps<TFieldValues extends FieldValues, TFieldArrayName extends PathString> = {
    name: Auto.FieldArrayPath<TFieldValues, TFieldArrayName>;
    control?: Control<TFieldValues>;
    shouldUnregister?: boolean;
};
export declare type FieldArrayWithId<TFieldValues extends FieldValues = FieldValues, TFieldArrayName extends PathString = never> = FieldArray<TFieldValues, TFieldArrayName> & Record<'id', string>;
export declare type FieldArray<TFieldValues extends FieldValues, TFieldArrayName extends PathString> = FieldPathValue<TFieldValues, TFieldArrayName> extends ReadonlyArray<infer U> | null | undefined ? U : never;
export declare type FieldArrayMethodProps = {
    shouldFocus?: boolean;
    focusIndex?: number;
    focusName?: string;
};
export declare type UseFieldArrayReturn<TFieldValues extends FieldValues, TFieldArrayName extends PathString> = {
    swap: (indexA: number, indexB: number) => void;
    move: (indexA: number, indexB: number) => void;
    prepend: (value: Partial<FieldArray<TFieldValues, TFieldArrayName>> | Partial<FieldArray<TFieldValues, TFieldArrayName>>[], options?: FieldArrayMethodProps) => void;
    append: (value: Partial<FieldArray<TFieldValues, TFieldArrayName>> | Partial<FieldArray<TFieldValues, TFieldArrayName>>[], options?: FieldArrayMethodProps) => void;
    remove: (index?: number | number[]) => void;
    insert: (index: number, value: Partial<FieldArray<TFieldValues, TFieldArrayName>> | Partial<FieldArray<TFieldValues, TFieldArrayName>>[], options?: FieldArrayMethodProps) => void;
    update: (index: number, value: Partial<FieldArray<TFieldValues, TFieldArrayName>>) => void;
    replace: (value: Partial<FieldArray<TFieldValues, TFieldArrayName>> | Partial<FieldArray<TFieldValues, TFieldArrayName>>[]) => void;
    fields: FieldArrayWithId<TFieldValues, TFieldArrayName>[];
};
//# sourceMappingURL=fieldArray.d.ts.map